NXWidgets: NxWM::CApplicationWindow Class Reference

NXWidgets 1.19

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
NxWM::CApplicationWindow Class Reference

`#include <capplicationwindow.hxx>`

Inheritance diagram for NxWM::CApplicationWindow:

## Public Types
enum | EWindowFlags { WINDOW_PERSISTENT = 0x01 }

## Public Member Functions
| CApplicationWindow (NXWidgets::CNxTkWindow *window, uint8_t flags=0)
| ~CApplicationWindow (void)
bool | open (void)
void | redraw (void)
void | hide (void)
NXWidgets::INxWindow * | getWindow (void) const
NXWidgets::CWidgetControl * | getWidgetControl (void) const
void | block (IApplication *app)
void | setWindowLabel (NXWidgets::CNxString &appname)
bool | isFullScreen (void) const
void | registerCallbacks (IApplicationCallback *callback)
bool | isPersistent (void) const
void | clickMinimizePosition (bool click)
void | clickStopIcon (bool click)
Public Member Functions inherited from NxWM::IApplicationWindow
virtual | ~IApplicationWindow (void)

## Protected Member Functions
void | handleActionEvent (const NXWidgets::CWidgetEventArgs &e)

## Protected Attributes
NXWidgets::CNxTkWindow * | m_window
NXWidgets::CNxToolbar * | m_toolbar
NXWidgets::CImage * | m_minimizeImage
NXWidgets::CImage * | m_stopImage
NXWidgets::CLabel * | m_windowLabel
NXWidgets::CRlePaletteBitmap * | m_minimizeBitmap
NXWidgets::CRlePaletteBitmap * | m_stopBitmap
NXWidgets::CNxFont * | m_windowFont
IApplicationCallback * | m_callback
uint8_t | m_flags

## Additional Inherited Members
Private Member Functions inherited from NXWidgets::CWidgetEventHandler
| CWidgetEventHandler ()
virtual | ~CWidgetEventHandler ()
virtual void | handleClickEvent (const CWidgetEventArgs &e)
virtual void | handleDragEvent (const CWidgetEventArgs &e)
virtual void | handleDropEvent (const CWidgetEventArgs &e)
virtual void | handleReleaseEvent (const CWidgetEventArgs &e)
virtual void | handleReleaseOutsideEvent (const CWidgetEventArgs &e)
virtual void | handleKeyPressEvent (const CWidgetEventArgs &e)
virtual void | handleCursorControlEvent (const CWidgetEventArgs &e)
virtual void | handleFocusEvent (const CWidgetEventArgs &e)
virtual void | handleBlurEvent (const CWidgetEventArgs &e)
virtual void | handleCloseEvent (const CWidgetEventArgs &e)
virtual void | handleHideEvent (const CWidgetEventArgs &e)
virtual void | handleShowEvent (const CWidgetEventArgs &e)
virtual void | handleEnableEvent (const CWidgetEventArgs &e)
virtual void | handleDisableEvent (const CWidgetEventArgs &e)
virtual void | handleValueChangeEvent (const CWidgetEventArgs &e)
virtual void | handleResizeEvent (const CWidgetEventArgs &e)
virtual void | handleMoveEvent (const CWidgetEventArgs &e)
virtual void | handleScrollEvent (const CWidgetEventArgs &e)
virtual void | handleDoubleClickEvent (const CWidgetEventArgs &e)

## Detailed Description

This class represents that application window. This class contains that the framed window and its toolbar. It manages callbacks from the toolbar minimize and close buttions and passes these to the application via callbacks.

Definition at line 74 of file capplicationwindow.hxx.

## Member Enumeration Documentation

## ◆ EWindowFlags

enum NxWM::CApplicationWindow::EWindowFlags

Enumeration describing the bit settings for each window flag

Enumerator
WINDOW_PERSISTENT | Persistent windows have no stop button

Definition at line 82 of file capplicationwindow.hxx.

## Constructor & Destructor Documentation

## ◆ CApplicationWindow()

CApplicationWindow::CApplicationWindow | ( | NXWidgets::CNxTkWindow * | window,
|  | uint8_t | flags = `0`
| ) |  |

CApplicationWindow Constructor

Parameters

  window. | The window to be used by this application.
  flags. | Optional flags to control the window configuration (See EWindowFlags).

CApplicationWindow Constructor

Parameters

  taskbar. | A pointer to the parent task bar instance.
  flags. | Optional flags to control the window configuration (See EWindowFlags).

Definition at line 82 of file capplicationwindow.cxx.

## ◆ ~CApplicationWindow()

CApplicationWindow::~CApplicationWindow | ( | void |  | ) |

CApplicationWindow Destructor

Definition at line 111 of file capplicationwindow.cxx.

## Member Function Documentation

## ◆ block()

void CApplicationWindow::block | ( | IApplication * | app | ) |
| virtual

Block further activity on this window in preparation for window shutdown.

Parameters

  app. | The application to be blocked

Implements NxWM::IApplicationWindow.

Definition at line 457 of file capplicationwindow.cxx.

## ◆ clickMinimizePosition()

void CApplicationWindow::clickMinimizePosition | ( | bool | click | ) |
| virtual

Simulate a mouse click or release on the minimize icon. This method is only available for automated testing of NxWM.

Parameters

  click. | True to click; false to release;

Implements NxWM::IApplicationWindow.

Definition at line 510 of file capplicationwindow.cxx.

## ◆ clickStopIcon()

void CApplicationWindow::clickStopIcon | ( | bool | click | ) |
| virtual

Simulate a mouse click or release on the stop icon. This method is only available for automated testing of NxWM.

Parameters

  click. | True to click; false to release;

Implements NxWM::IApplicationWindow.

Definition at line 543 of file capplicationwindow.cxx.

## ◆ getWidgetControl()

NXWidgets::CWidgetControl * CApplicationWindow::getWidgetControl | ( | void |  | ) | const
| virtual

Recover the contained widget control

Returns
  . The widget control used by this application

Implements NxWM::IApplicationWindow.

Definition at line 445 of file capplicationwindow.cxx.

## ◆ getWindow()

NXWidgets::INxWindow * CApplicationWindow::getWindow | ( | void |  | ) | const
| virtual

Recover the contained NXTK window instance

Returns
  . The window used by this application

Implements NxWM::IApplicationWindow.

Definition at line 434 of file capplicationwindow.cxx.

## ◆ handleActionEvent()

void CApplicationWindow::handleActionEvent | ( | const NXWidgets::CWidgetEventArgs & | e | ) |
| protectedvirtual

Handle a widget action event. For CImage, this is a mouse button pre-release event.

Parameters

  e | The event data.

Reimplemented from NXWidgets::CWidgetEventHandler.

Definition at line 579 of file capplicationwindow.cxx.

## ◆ hide()

void CApplicationWindow::hide | ( | void |  | ) |
| virtual

The application window is hidden (either it is minimized or it is maximized, but not at the top of the hierarchy)

Implements NxWM::IApplicationWindow.

Definition at line 403 of file capplicationwindow.cxx.

## ◆ isFullScreen()

bool CApplicationWindow::isFullScreen | ( | void |  | ) | const
| virtual

Report of this is a "normal" window or a full screen window. The primary purpose of this method is so that window manager will know whether or not it show draw the task bar.

Returns
  True if this is a full screen window.

Implements NxWM::IApplicationWindow.

Definition at line 488 of file capplicationwindow.cxx.

## ◆ isPersistent()

bool NxWM::CApplicationWindow::isPersistent | ( | void |  | ) | const
| inline

Check if this window is configured for a persistent application (i.e., an application that has no STOP icon

Returns
  True if the window is configured for a persistent application.

Definition at line 202 of file capplicationwindow.hxx.

## ◆ open()

bool CApplicationWindow::open | ( | void |  | ) |
| virtual

Initialize window. Window initialization is separate from object instantiation so that failures can be reported.

Returns
  True if the window was successfully initialized.

Implements NxWM::IApplicationWindow.

Definition at line 166 of file capplicationwindow.cxx.

## ◆ redraw()

void CApplicationWindow::redraw | ( | void |  | ) |
| virtual

Re-draw the application window

Implements NxWM::IApplicationWindow.

Definition at line 349 of file capplicationwindow.cxx.

## ◆ registerCallbacks()

void CApplicationWindow::registerCallbacks | ( | IApplicationCallback * | callback | ) |
| virtual

Register to receive callbacks when toolbar icons are selected

Implements NxWM::IApplicationWindow.

Definition at line 497 of file capplicationwindow.cxx.

## ◆ setWindowLabel()

void CApplicationWindow::setWindowLabel | ( | NXWidgets::CNxString & | appname | ) |
| virtual

Set the window label

Parameters

  appname. | The name of the application to place on the window

Implements NxWM::IApplicationWindow.

Definition at line 475 of file capplicationwindow.cxx.

## Member Data Documentation

## ◆ m_callback

IApplicationCallback* NxWM::CApplicationWindow::m_callback
| protected

Toolbar action callbacks

Definition at line 96 of file capplicationwindow.hxx.

## ◆ m_flags

uint8_t NxWM::CApplicationWindow::m_flags
| protected

Window flags

Definition at line 97 of file capplicationwindow.hxx.

## ◆ m_minimizeBitmap

NXWidgets::CRlePaletteBitmap* NxWM::CApplicationWindow::m_minimizeBitmap
| protected

The minimize icon bitmap

Definition at line 93 of file capplicationwindow.hxx.

## ◆ m_minimizeImage

NXWidgets::CImage* NxWM::CApplicationWindow::m_minimizeImage
| protected

The minimize icon

Definition at line 90 of file capplicationwindow.hxx.

## ◆ m_stopBitmap

NXWidgets::CRlePaletteBitmap* NxWM::CApplicationWindow::m_stopBitmap
| protected

The stop icon bitmap

Definition at line 94 of file capplicationwindow.hxx.

## ◆ m_stopImage

NXWidgets::CImage* NxWM::CApplicationWindow::m_stopImage
| protected

The close icon

Definition at line 91 of file capplicationwindow.hxx.

## ◆ m_toolbar

NXWidgets::CNxToolbar* NxWM::CApplicationWindow::m_toolbar
| protected

The toolbar

Definition at line 89 of file capplicationwindow.hxx.

## ◆ m_window

NXWidgets::CNxTkWindow* NxWM::CApplicationWindow::m_window
| protected

The framed window used by the application

Definition at line 88 of file capplicationwindow.hxx.

## ◆ m_windowFont

NXWidgets::CNxFont* NxWM::CApplicationWindow::m_windowFont
| protected

The font used to rend the window label

Definition at line 95 of file capplicationwindow.hxx.

## ◆ m_windowLabel

NXWidgets::CLabel* NxWM::CApplicationWindow::m_windowLabel
| protected

The window title

Definition at line 92 of file capplicationwindow.hxx.

The documentation for this class was generated from the following files:

- capplicationwindow.hxx
- capplicationwindow.cxx